----------------------------------------------------------------------
--
-- Filename: microblaze_brd_zbt_clkgen.vhd
--
-- Description:
--
--
--                  Author: Mark Paluszkiewicz
--                  Staff  Engineer
--
--                  Xilinx Labs
--                  Xilinx, Inc.
--
--                  Copyright (c) 2001-2003 Xilinx, Inc.
--                  All rights reserved
--
--                  Date:   January 20 2003
--                  For:    Demo example using the MicroBlaze Multi-media board REV C
--
--                  RESTRICTED RIGHTS LEGEND
--
--      This software/hdl has not been published by the author, and
--      has been disclosed to others for the purpose of enhancing
--      and promoting design productivity in Xilinx products.
--
--      Therefore use, duplication or disclosure, now and in the
--      future should give consideration to the productivity
--      enhancements afforded the user of this code by the author's
--      efforts.  Thank you for using our products !
--
-- Disclaimer:  THESE DESIGNS ARE PROVIDED "AS IS" WITH NO WARRANTY
--              WHATSOEVER AND XILINX SPECIFICALLY DISCLAIMS ANY
--              IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR
--              A PARTICULAR PURPOSE, OR AGAINST INFRINGEMENT.
--
--
--
-- Revision: 1.0.0.a
--     05 - 13 - 2003
--
--
----------------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_UNSIGNED.all;

-- synthesis translate_off
library unisim;
use unisim.vcomponents.all;
-- synthesis translate_on



entity microblaze_brd_zbt_clkgen is
port (
        -- inputs
        -- clock & dll feed backs sys reset
MASTER_CLOCK_P      : in std_logic;
LINE_LOCKED_CLOCK1  : in std_logic;
EXTEND_DCM_RESET_P  : in std_logic;
  --MEM_CLK_FBIN_P      : in std_logic; -- not used in this version
  --RX_CLOCK_P          : in std_logic; -- not used in this version
  --TX_CLOCK_P          : in std_logic; -- not used in this version
MEM_CLK_FBOUT_P     : out std_logic;
  --MEMORY_BANK1_CLK_P  : out std_logic; -- not used in this version
MEMORY_BANK2_CLK_P  : out std_logic;
clk_27mhz           : out  std_logic;
LINE_LOCKED_CLOCK   : out  std_logic;
clk_81mhz           : out std_logic;
  --emac_tx_clock       : out std_logic; -- not used in this version
  --emac_rx_clock       : out std_logic; -- not used in this version
fpga_reset          : out std_logic;
ENET_SLEW_P         : out std_logic_vector(1 downto 0);
PAUSE_P             : out std_logic;
MDIO_P              : out std_logic;
MDC_P               : out std_logic;
STARTUP_P           : out std_logic
);
end microblaze_brd_zbt_clkgen;

architecture STRUCT of microblaze_brd_zbt_clkgen is


signal fb_clk_27mhz         :  std_logic;
signal LINE_LOCKED_CLOCK_int :  std_logic;
  --signal fb_clk_50mhz         :  std_logic;  -- not used in this version
  --signal fb_clk_40mhz         :  std_logic;  -- not used in this version
signal fb_clk_81mhz         :  std_logic;
signal clk_81mhz_int        :  std_logic;
signal clk50mhz             :  std_logic;
signal clk54mhz             :  std_logic;
signal clk40mhz             :  std_logic;
signal int_vid_clk_27mhz    :  std_logic;
signal int_clk_81mhz        :  std_logic;
signal mem_clk81mhz         :  std_logic;
signal memory_27mhz         :  std_logic;
signal memory_54mhz         :  std_logic;
signal memory_81mhz         :  std_logic;
signal int_rx_clock         :  std_logic;
signal int_tx_clock         :  std_logic;
signal master_clock         :  std_logic;
signal clk27mhz             :  std_logic;
signal clk81mhz             :  std_logic;
signal enet_ref_clk         :  std_logic;
signal mem_clk_fbout        :  std_logic;
signal mem_clk_fbin         :  std_logic;
signal extend_dcm_reset     :  std_logic;
signal dcm_reset            :  std_logic;
signal main_locked          :  std_logic;
signal memory_locked        :  std_logic;
signal alternate_clock      :  std_logic;
signal enable_reset_counter :  std_logic;
signal terminal_count       :  std_logic;
signal dcm_reset_counter    :  std_logic_vector(15 downto 0);
signal not_fb_clk_81mhz     :  std_logic; 
signal vcc                  :  std_logic;
signal gnd                  :  std_logic;

component IBUFG
port (
        I : in std_logic;
        O : out std_logic);
end component;

component IBUF
port (
        I : in std_logic;
        O : out std_logic);
end component;

component BUFG
port (
        I : in std_logic;
        O : out std_logic);
end component;

component OBUF_F_12
port (
        I : in std_logic;
        O : out std_logic);
end component;

component BUFGMUX
port (
        I0 : in std_logic;
        I1 : in std_logic;
        S  : in std_logic;
        O  : out std_logic);
end component;

component FDDRCPE
port (
   Q : out std_logic;
   C0 : in std_logic;
   C1 : in std_logic;
   CE : in std_logic;
   CLR : in std_logic;
   D0 : in std_logic;
   D1 : in std_logic;
   PRE : in std_logic
);
end component;

component DCM
        -- synthesis translate_off
generic (
        DLL_FREQUENCY_MODE : string := "LOW";
        DUTY_CYCLE_CORRECTION : boolean := TRUE;
        STARTUP_WAIT : boolean := FALSE;
        DFS_FREQUENCY_MODE : string := "LOW";
        CLKFX_DIVIDE : integer := 1;
        CLKFX_MULTIPLY : integer := 3 ;
        CLK_FEEDBACK : string := "1X";
        CLKIN_DIVIDE : boolean := FALSE;
        CLKOUT_PHASE_SHIFT : string := "NONE";
        PHASE_SHIFT : integer := 0;
        DSS_MODE : string := "NONE"
);
  -- synthesis translate_on
port (
   CLKFB    : in std_logic;
   CLKIN    : in std_logic;
   DSSEN    : in std_logic;
   PSCLK    : in std_logic;
   PSEN     : in std_logic;
   PSINCDEC : in std_logic;
   RST      : in std_logic;
   CLK0     : out std_logic;
   CLK90    : out std_logic;
   CLK180   : out std_logic;
   CLK270   : out std_logic;
   CLK2X    : out std_logic;
   CLK2X180 : out std_logic;
   CLKDV    : out std_logic;
   CLKFX    : out std_logic;
   CLKFX180 : out std_logic;
   LOCKED   : out std_logic;
   PSDONE   : out std_logic;
   STATUS   : out std_logic_vector(7 downto 0));
end component;


begin

MDIO_P               <=      vcc; --tie high
MDC_P                <=       vcc; --tie high
ENET_SLEW_P          <= "00" ; -- tie low
PAUSE_P              <= gnd;  -- tie low
clk_81mhz            <= fb_clk_81mhz;
clk_27mhz            <= fb_clk_27mhz  ;
dcm_reset            <= not dcm_reset_counter(15);
enable_reset_counter <= not terminal_count AND extend_dcm_reset;
STARTUP_P            <=  main_locked ; -- dll is locked allow emac and other to come out of reset
fpga_reset           <= not main_locked ;
not_fb_clk_81mhz     <= not fb_clk_81mhz;
gnd                  <= '0';
vcc                  <= '1';

  -- fb_clk_40mhz <=  clk_40mhz;  -- not used in this design
  -- clk_50mhz <= fb_clk_50mhz; -- not used in this version

dcm_reset_counter_inst : process (master_clock)
begin
  if(master_clock='1' and master_clock'event) then
          if(enable_reset_counter = '1') then
                  dcm_reset_counter <=  dcm_reset_counter + 1;
          end if;
        end if;
end process;

Decode_term_count : process (dcm_reset_counter)
begin
        if(dcm_reset_counter = "1111111111111111") then
            terminal_count <= '1';
        else
             terminal_count <= '0';
        end if;
end process;




MASTER_CLOCK_inst              : IBUFG port map ( I => MASTER_CLOCK_P, O => master_clock);
LINE_LOCKED_CLOCK1_inst        : IBUFG port map ( I => LINE_LOCKED_CLOCK1, O => LINE_LOCKED_CLOCK_int);
CLK27_BUF_inst                 : BUFG port map (I => clk27mhz, O => fb_clk_27mhz);
LINE_LOCKED_CLOCK_int_BUF_inst : BUFG port map (I => LINE_LOCKED_CLOCK_int, O => LINE_LOCKED_CLOCK);
CLK81_BUF_int_inst             : BUFG port map (I => clk81mhz, O => clk_81mhz_int);
CLK81_BUF_inst                 : BUFG port map (I => mem_clk81mhz, O => fb_clk_81mhz);
DCM_RESET_inst                 : IBUF port map (I => EXTEND_DCM_RESET_P, O => extend_dcm_reset);

  --- buffering for ethernet clocks not used in this demo verions
  --CLK_EMAC_TX_BUF_inst : BUFG port map (I => int_tx_clock, O => emac_tx_clock);
  --CLK_EMAC_RX_BUF_inst  : BUFG port map (I => int_rx_clock, O => emac_rx_clock);
  --ENET_RX_CLOCK_IN_inst  : IBUFG port map ( I => RX_CLOCK_P , O => int_rx_clock );
  --ENET_TX_CLOCK_IN_inst  : IBUFG port map ( I => TX_CLOCK_P , O => int_tx_clock );


--MEMORY_BANK1_CLK_OUT_inst :FDDRCPE port map(
--Q    =>  MEMORY_BANK1_CLK_P ,
--C0   => fb_clk_81mhz ,
--C1   => not  fb_clk_81mhz ,
--CE   => vcc ,
--CLR  => gnd ,
--D0   => vcc ,
--D1   => gnd ,
--PRE  => gnd
--);

MEMORY_BANK2_CLK_OUT_inst  : FDDRCPE port map(
Q    => MEMORY_BANK2_CLK_P ,
C0   => fb_clk_81mhz ,
C1   => not_fb_clk_81mhz ,
CE   => vcc ,
CLR  => gnd ,
D0   => vcc ,
D1   => gnd ,
PRE  => gnd
);


  --MEMORY_FB_OUT : OBUF_F_12 port map (I => mem_clk_fbout, O => MEM_CLK_FBOUT_P);
-- MEMORY_FB_OUT_inst :FDDRCPE port map(
-- Q    => MEM_CLK_FBOUT_P ,
-- C0   => fb_clk_81mhz ,
-- C1   => not  fb_clk_81mhz ,
-- CE   => vcc ,
-- CLR  => gnd ,
-- D0   => vcc ,
-- D1   => gnd ,
-- PRE  => gnd
-- );


MAIN_DCM : DCM
-- synthesis translate_off
generic map (
DLL_FREQUENCY_MODE => "LOW",
DUTY_CYCLE_CORRECTION => TRUE,
STARTUP_WAIT => FALSE,
DFS_FREQUENCY_MODE => "LOW",
CLKFX_DIVIDE => 1,
CLKFX_MULTIPLY => 3,
CLK_FEEDBACK => "1X",
CLKOUT_PHASE_SHIFT => "NONE",
PHASE_SHIFT => 0 )
-- synthesis translate_on
port map (
   CLKFB      => fb_clk_27mhz,
   CLKIN      => master_clock,
   DSSEN      => '0',
   PSCLK      => '0',
   PSEN       => '0',
   PSINCDEC   => '0',
   RST        => dcm_reset,
   CLK0       => clk27mhz,
   CLK2X      => clk54mhz,
   CLKFX      => clk81mhz,
   LOCKED     => main_locked
);


MEMORY_DCM : DCM
-- synthesis translate_off
generic map (
DLL_FREQUENCY_MODE    => "LOW",
DUTY_CYCLE_CORRECTION => TRUE,
STARTUP_WAIT          => FALSE,
DFS_FREQUENCY_MODE    => "LOW",
CLKFX_DIVIDE          => 1,
CLKFX_MULTIPLY        => 1,
CLK_FEEDBACK          => "1X",
CLKOUT_PHASE_SHIFT    => "NONE",
PHASE_SHIFT           => 0 )
-- synthesis translate_on
port map (
   CLKFB                  => fb_clk_81mhz,
   CLKIN                  => clk_81mhz_int,
   DSSEN                  => '0',
   PSCLK                  => '0',
   PSEN                   => '0',
   PSINCDEC               => '0',
   RST                    => dcm_reset,
   CLK0                   => mem_clk81mhz,
   CLKDV                  => clk40mhz,
   CLK2X                  => open,
   CLKFX                  => open,
   LOCKED                 => memory_locked
);


end  STRUCT;
