----------------------------------------------------------------------
-- 
-- Filename: resync.vhd 
--
-- Description: 
--
--
--                  Author: Mark Paluszkiewicz
--                  Staff  Engineer
--
--                  Xilinx Labs
--                  Xilinx, Inc.
--
--                  Copyright (c) 2001-2002 Xilinx, Inc.
--                  All rights reserved
--
--                  Date:   July 1 2002
--                  For:    JPEG2000 Encoder
--
--                  RESTRICTED RIGHTS LEGEND
--
--      This software/hdl has not been published by the author, and
--      has been disclosed to others for the purpose of enhancing
--      and promoting design productivity in Xilinx products.
--
--      Therefore use, duplication or disclosure, now and in the
--      future should give consideration to the productivity
--      enhancements afforded the user of this code by the author's
--      efforts.  Thank you for using our products !
--
-- Disclaimer:  THESE DESIGNS ARE PROVIDED "AS IS" WITH NO WARRANTY
--              WHATSOEVER AND XILINX SPECIFICALLY DISCLAIMS ANY
--              IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR
--              A PARTICULAR PURPOSE, OR AGAINST INFRINGEMENT.
--
--
--
-- Revision:
--      07/01/2002 MP Created this version Un-released
--			
--
----------------------------------------------------------------------



library IEEE; 
--library virtex2; 
use IEEE.std_logic_1164.all;
use IEEE.std_logic_UNSIGNED.all;
--use virtex2.components.all;
-- synthesis translate_off
library unisim;
use unisim.vcomponents.all;
-- synthesis translate_on 



  entity vid_resync_buf is 
  port (
  reset    : in std_logic;
  vid_27mhz_input_clock            : in std_logic;
  vid_27mhz_output_clock	            : in std_logic;
  --cei          			: in std_logic;
  YCrCb_input                 : in std_logic_vector(9 downto 0);
  YCrCb_reg_out         : out std_logic_vector(9 downto 0)
  );
  end vid_resync_buf;
	 
  architecture STRUCT of vid_resync_buf is 
--COMPONENT vidgen
--PORT(
--	ce_a : IN std_logic;
--	ce_b : IN std_logic;
--	clk_a : IN std_logic;
--	clk_b : IN std_logic;
--	pattern_a : IN std_logic;
--	pattern_b : IN std_logic;
--	rst_a : IN std_logic;
--	rst_b : IN std_logic;          
--	h_sync_b : OUT std_logic;
--	field_a : OUT std_logic;
--	field_b : OUT std_logic;
--	v_sync_a : OUT std_logic;
--	v_sync_b : OUT std_logic;
--	h_sync_a : OUT std_logic;
--	q_a : OUT std_logic_vector(9 downto 0);
--	q_b : OUT std_logic_vector(9 downto 0)
--);
--END COMPONENT;
--attribute syn_black_box of vidgen : component is true;

component RAMB16_S9_S9
-- synthesis translate_off
  generic (
       WRITE_MODE_A : string := "WRITE_FIRST";
       WRITE_MODE_B : string := "WRITE_FIRST";
       INIT_A : bit_vector := X"000";
       SRVAL_A : bit_vector  := X"000";

       INIT_B : bit_vector  := X"000";
       SRVAL_B : bit_vector  := X"000";

       INITP_00 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INITP_01 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INITP_02 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INITP_03 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_00 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_01 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_02 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_03 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
  );
-- synthesis translate_on
  port (DIA    : in STD_LOGIC_VECTOR (7 downto 0);
        DIB    : in STD_LOGIC_VECTOR (7 downto 0);
        DIPA    : in STD_LOGIC_VECTOR (0 downto 0);
        DIPB    : in STD_LOGIC_VECTOR (0 downto 0);
        ENA    : in STD_logic;
        ENB    : in STD_logic;
        WEA    : in STD_logic;
        WEB    : in STD_logic;
        SSRA   : in STD_logic;
        SSRB   : in STD_logic;
        CLKA   : in STD_logic;
        CLKB   : in STD_logic;
        ADDRA  : in STD_LOGIC_VECTOR (10 downto 0);
        ADDRB  : in STD_LOGIC_VECTOR (10 downto 0);
        DOA    : out STD_LOGIC_VECTOR (7 downto 0);
        DOB    : out STD_LOGIC_VECTOR (7 downto 0);
        DOPA    : out STD_LOGIC_VECTOR (0 downto 0);
        DOPB    : out STD_LOGIC_VECTOR (0 downto 0)
       ); 

end component;
	 


--attribute INIT_00: string;
--attribute INIT_01: string;


--attribute INIT_00 of RAMB_EXAMPLE : label is "0000000000000000000000000000000000000000000000000000000000000000";
--attribute INIT_01 of RAMB_EXAMPLE : label is "0000000000000000000000000000000000000000000000000000000000000000";
	signal lf_YCrCb_test         : std_logic_vector(9 downto 0);
	signal gnd_bus3  			: std_logic_vector(2 downto 0);
	signal gnd_bus8  			: std_logic_vector(7 downto 0);
	signal decode_count  		: std_logic_vector(10 downto 0);
	signal encoder_count  		: std_logic_vector(10 downto 0);
	signal YCrCb_reg		    : std_logic_vector(9 downto 0);
	signal YCrCb_mux_reg    	: std_logic_vector(9 downto 0);
	signal YCrCb_resync_out  	: std_logic_vector(9 downto 0);
	signal field_a : std_logic;
  signal field_b : std_logic;
    signal cei                  : std_logic;
	signal vcc 					: std_logic;
	signal gnd 					: std_logic;
	signal gnd_v 				: STD_LOGIC_VECTOR (0 downto 0);




  begin
	
	gnd_v <= "0";
	gnd_bus3 <=  "000";
	gnd_bus8 <=  "00000000";
	cei <= '1';
	vcc <= '1';	
	gnd <= '0';
--	YCrCb_mux_reg_out <= YCrCb_mux_reg;

--	ycrcb_in_reg : process (vid_27mhz_output_clock, reset )
--	begin
--	if reset = '1'then
--	  YCrCb_reg <= "0000000000";
--	  elsif(vid_27mhz_output_clock='1' and vid_27mhz_output_clock'event) then
--	  YCrCb_reg <= YCrCb;
--	  end if;
--    end process;


--ycrcb_in_reg : process (vid_27mhz_output_clock )
--begin
--	if(vid_27mhz_output_clock='1' and vid_27mhz_output_clock'event) then
--	  YCrCb_reg <= YCrCb;
--	end if;
--end process;

--   mux_vid_enc_out_reg : process (vid_27mhz_output_clock, reset )
--	begin
--	if (reset = '1')then
--	YCrCb_mux_reg <= "0000000000";
--	elsif(vid_27mhz_output_clock='1' and vid_27mhz_output_clock'event) then
--		if (sel_test_pat = '1') then
--    YCrCb_mux_reg <=  lf_YCrCb_test;
--		else
--		YCrCb_mux_reg <=   YCrCb_reg;
--		end if;
--	end if;
--    end process;

-- mux_vid_enc_out_reg : process (vid_clk, reset )
--	begin
--	if( reset = '1' )then
--	YCrCb_reg_out <= "0000000000";
--	elsif(vid_clk='1' and vid_clk'event) then
--    -- YCrCb_reg_out <=  YCrCb_mux_reg_out;
--	YCrCb_reg_out <= YCrCb_resync_out;
--	end if;
--    end process;

mux_vid_enc_out_reg : process (vid_27mhz_output_clock)
begin
	if(vid_27mhz_output_clock='1' and vid_27mhz_output_clock'event) then
  	YCrCb_reg_out <= YCrCb_resync_out;
	end if;
end process;

	decoder_counter : process (vid_27mhz_input_clock, reset )
	begin
	if( reset = '1') then
	  decode_count <= "00000000000";
		elsif(vid_27mhz_input_clock='1' and vid_27mhz_input_clock'event) then
			if cei ='1' then
	  	decode_count <=  decode_count + 1;
			else
			decode_count <=  decode_count;
			end if;
	end if;
	end process;


	encoder_counter : process (vid_27mhz_output_clock, reset )
	begin
	if( reset = '1') then
	  encoder_count  <= "01111111111";
	  elsif(vid_27mhz_output_clock='1' and vid_27mhz_output_clock'event) then
	  encoder_count <=  encoder_count + 1;
		end if;
	end process;

--	Inst_vidgen : vidgen
--PORT MAP(
--	h_sync_b => open ,
--	ce_a => vcc ,
--	ce_b => vcc ,
--	field_a => field_a,
--	clk_a => vid_27mhz_output_clock ,
--	field_b => field_b ,
--	clk_b => vid_27mhz_output_clock ,
--	pattern_a =>  gnd,
--	pattern_b => vcc ,
--	v_sync_a => open ,
--	v_sync_b => open ,
--	rst_a => reset ,
--	rst_b =>  reset ,
--	h_sync_a => open ,
--	q_a => lf_YCrCb_test ,
--	q_b => open
--);

	resync_ram0 : RAMB16_S9_S9 port map (
		DIA (4 downto 0)   =>  YCrCb_input(4 downto 0),
		DIA (7 downto 5)   => gnd_bus3,
        DIB   => gnd_bus8, 
		DIPA  => gnd_v,
        DIPB  => gnd_v,
        ENA   => vcc, 
        ENB   => vcc,
        WEA   => cei,
        WEB   => gnd,
        SSRA  => gnd,
        SSRB  => gnd,
        CLKA  => vid_27mhz_input_clock,
        CLKB  => vid_27mhz_output_clock,
        ADDRA => decode_count,
        ADDRB => encoder_count,
        DOA   => open,
		DOB(7 downto 5) => open,
        DOB(4 downto 0) =>  YCrCb_resync_out(4 downto 0),
		DOPA  => open,
        DOPB  => open
		); 
resync_ram1 : RAMB16_S9_S9 port map (
		DIA (4 downto 0)   =>  YCrCb_input(9 downto 5),
		DIA (7 downto 5)   => gnd_bus3,
        DIB   => gnd_bus8, 
		DIPA  => gnd_v,
        DIPB  => gnd_v,
        ENA   => vcc, 
        ENB   => vcc,
        WEA   => cei,
        WEB   => gnd,
        SSRA  => gnd,
        SSRB  => gnd,
        CLKA  => vid_27mhz_input_clock,
        CLKB  => vid_27mhz_output_clock,
        ADDRA => decode_count,
        ADDRB => encoder_count,
        DOA   => open,
		DOB(7 downto 5) => open,
        DOB(4 downto 0) =>  YCrCb_resync_out(9 downto 5),
		DOPA  => open,
        DOPB  => open
		); 

	end  STRUCT; 
