#################################################################
# Makefile generated by Xilinx Platform Studio 
# Project:D:\Documenti\tmp\videoelab\system.xmp
#################################################################

# Name of the Microprocessor system
# The hardware specification of the system is in file :
# D:\Documenti\tmp\videoelab\system.mhs
# The software specification of the system is in file :
# D:\Documenti\tmp\videoelab\system.mss

SYSTEM = system

MHSFILE = system.mhs

MSSFILE = system.mss

FPGA_ARCH = virtex2

DEVICE = xc2v2000ff896-4

LANGUAGE = vhdl

SEARCHPATHOPT = 

PLATGEN_OPTIONS = -p $(DEVICE) -lang $(LANGUAGE) $(SEARCHPATHOPT) 

LIBGEN_OPTIONS = -mhs $(MHSFILE) -p $(FPGA_ARCH) $(SEARCHPATHOPT) \
                   $(MICROBLAZE_INST_LIBG_OPT)

SIM_CMD = vsim

BEHAVIORAL_DO_SCRIPT = simulation/behavioral/$(SYSTEM).do

STRUCTURAL_DO_SCRIPT = simulation/structural/$(SYSTEM).do

TIMING_DO_SCRIPT = simulation/timing/$(SYSTEM).do

DEFAULT_SIM_DO_SCRIPT = $(BEHAVIORAL_DO_SCRIPT)

SIMGEN_OPTIONS = -p $(FPGA_ARCH) -lang $(LANGUAGE) $(SEARCHPATHOPT) -s mti

MICROBLAZE_INST_OUTPUT = videoelab.elf

LIBRARIES =  \
       microblaze_inst/lib/libxil.a 


#################################################################
# EXTERNAL TARGETS
#################################################################
all:
	@echo "Makefile to build a Microprocessor system :"
	@echo "Run make with any of the following targets"
	@echo " "
	@echo "  netlist  : Generates the netlist for the given MHS "
	@echo "  bits     : Runs Implementation tools to generate the bitstream"
	@echo "  exporttopn:Export to ProjNav"
	@echo " "
	@echo "  libs     : Configures the sw libraries for this system"
	@echo "  program  : Compiles the program sources for all the processor instances"
	@echo "  bsp      : Generate a bsp for vxworks"
	@echo " "
	@echo "  init_bram: Initializes bitstream with BRAM data"
	@echo "  ace      : Generate ace file from bitstream and elf"
	@echo "  download : Downloads the bitstream onto the board"
	@echo " "
	@echo "  sim      : Generates HDL simulation models and runs simulator for chosen simulation mode"
	@echo "  simmodel : Generates HDL simulation models for chosen simulation mode"
	@echo "  behavioral:Generates behavioral HDL models with BRAM initialization"
	@echo "  structural:Generates structural simulation HDL models with BRAM initialization"
	@echo "  timing   : Generates timing simulation HDL models with BRAM initialization"
	@echo " "
	@echo "  netlistclean: Deletes netlist"
	@echo "  bitsclean: Deletes bit, ncd, bmm files"
	@echo "  hwclean  : Deletes implementation dir"
	@echo "  libsclean: Deletes sw libraries"
	@echo "  programclean: Deletes compiled ELF files"
	@echo "  swclean  : Deletes sw libraries and ELF files"
	@echo "  simclean : Deletes simulation dir"
	@echo "  clean    : Deletes all generated files/directories"
	@echo " "
	@echo "  make <target> : (Default)"
	@echo "      Creates a Microprocessor system using default initializations"
	@echo "      specified for each processor in MSS file"


bits: implementation/$(SYSTEM).bit

ace: implementation/$(SYSTEM).ace

netlist: implementation/$(SYSTEM).ngc

libs: $(LIBRARIES)

program: $(MICROBLAZE_INST_OUTPUT) 

bsp: 
	@echo "To generate BSP, please specify VxWorks5_4/VxWorks5_5 as OS for atleast one PPC405 instance"

download: implementation/download.bit dummy
	@echo "*********************************************"
	@echo "Downloading Bitstream onto the target board"
	@echo "*********************************************"
	impact -batch etc/download.cmd

init_bram: implementation/download.bit

sim: $(DEFAULT_SIM_DO_SCRIPT)
	cd simulation/behavioral; \
	$(SIM_CMD) -do $(SYSTEM).do &

simmodel: $(DEFAULT_SIM_DO_SCRIPT)

behavioral_model: $(BEHAVIORAL_DO_SCRIPT)

structural_model: $(STRUCTURAL_DO_SCRIPT)

timing_model: $(TIMING_DO_SCRIPT)

clean: hwclean libsclean programclean simclean
	rm -f _impact.cmd

hwclean: netlistclean bitsclean
	rm -rf implementation synthesis xst hdl
	rm -rf xst.srp $(SYSTEM).srp

netlistclean:
	rm -f implementation/$(SYSTEM).ngc

bitsclean:
	rm -f implementation/$(SYSTEM).bit
	rm -f implementation/$(SYSTEM).ncd
	rm -f implementation/$(SYSTEM)_bd.bmm 

bitsclean:

simclean: 
	rm -rf simulation/behavioral

swclean: libsclean programclean
	@echo ""

libsclean: MICROBLAZE_INST_LIBSCLEAN 

programclean: MICROBLAZE_INST_PROGRAMCLEAN 

#################################################################
# TARGETS/MACROS FOR PROCESSOR MICROBLAZE_INST
#################################################################

MICROBLAZE_INST_SOURCES = code/videoelab.c code/gpio.c 

MICROBLAZE_INST_HEADERS = code/gpio.h 

MICROBLAZE_INST_CC = mb-gcc
MICROBLAZE_INST_CC_SIZE = mb-size
MICROBLAZE_INST_CC_OPT = -O1
MICROBLAZE_INST_CFLAGS = 
MICROBLAZE_INST_CC_SEARCH = # -B
MICROBLAZE_INST_LIBPATH = -L./microblaze_inst/lib/ # -L
MICROBLAZE_INST_INCLUDES = -I./microblaze_inst/include/  -Icode/ # -I
MICROBLAZE_INST_LFLAGS = # -l

MICROBLAZE_INST_CC_FLOW =  # -[E|S|c]
MICROBLAZE_INST_CC_PREPROC_FLAG = # -Wp,
MICROBLAZE_INST_CC_ASM_FLAG = # -Wa,
MICROBLAZE_INST_CC_LINKER_FLAG = # -Wl,
MICROBLAZE_INST_LINKER_SCRIPT = #-Wl,-T -Wl,
MICROBLAZE_INST_CC_DEBUG_FLAG = # -[g|gstabs]
MICROBLAZE_INST_CC_GLOBPTR_FLAG= # -mxl-gp-opt
MICROBLAZE_INST_MODE = executable
MICROBLAZE_INST_LIBG_OPT = -$(MICROBLAZE_INST_MODE) microblaze_inst
MICROBLAZE_INST_CC_SOFTMUL_FLAG= # -mno-xl-soft-mul 
MICROBLAZE_INST_CC_START_ADDR_FLAG= -Wl,-defsym -Wl,_TEXT_START_ADDR=0x00000000
MICROBLAZE_INST_CC_STACK_SIZE_FLAG=  -Wl,-defsym -Wl,_STACK_SIZE=0x1000
MICROBLAZE_INST_OTHER_CC_FLAGS= $(MICROBLAZE_INST_CC_FLOW) $(MICROBLAZE_INST_CC_GLOBPTR_FLAG)  \
                  $(MICROBLAZE_INST_CC_START_ADDR_FLAG) $(MICROBLAZE_INST_CC_STACK_SIZE_FLAG)  \
                  $(MICROBLAZE_INST_CC_SOFTMUL_FLAG)  \
                  $(MICROBLAZE_INST_CC_PREPROC_FLAG) $(MICROBLAZE_INST_CC_ASM_FLAG) $(MICROBLAZE_INST_CC_LINKER_FLAG)  \
                  $(MICROBLAZE_INST_LINKER_SCRIPT) $(MICROBLAZE_INST_CC_DEBUG_FLAG) 

$(MICROBLAZE_INST_OUTPUT) : $(MICROBLAZE_INST_SOURCES) $(MICROBLAZE_INST_HEADERS) $(LIBRARIES) __xps/microblaze_inst_compiler.opt 
	$(MICROBLAZE_INST_CC) $(MICROBLAZE_INST_CFLAGS) $(MICROBLAZE_INST_CC_OPT) $(MICROBLAZE_INST_SOURCES) -o $(MICROBLAZE_INST_OUTPUT)  \
	$(MICROBLAZE_INST_OTHER_CC_FLAGS) $(MICROBLAZE_INST_INCLUDES) $(MICROBLAZE_INST_LIBPATH)  \
	-xl-mode-$(MICROBLAZE_INST_MODE)  \
	$(MICROBLAZE_INST_LFLAGS) 
	$(MICROBLAZE_INST_CC_SIZE) $(MICROBLAZE_INST_OUTPUT) 

MICROBLAZE_INST_LIBSCLEAN:
	rm -rf microblaze_inst/lib/

MICROBLAZE_INST_PROGRAMCLEAN:
	rm -f $(MICROBLAZE_INST_OUTPUT) 

#################################################################
# TARGETS/MACROS FOR XILINX IMPLEMENTATION FLOW
#################################################################


implementation/download.bit: implementation/$(SYSTEM).bit  $(MICROBLAZE_INST_OUTPUT) 
	@cp -f implementation/$(SYSTEM)_bd.bmm .
	@echo "*********************************************"
	@echo "Initializing BRAM contents of the bitstream"
	@echo "*********************************************"
	bitinit $(MHSFILE) $(SEARCHPATHOPT)  -pe microblaze_inst $(MICROBLAZE_INST_OUTPUT)  -bt implementation/$(SYSTEM).bit -o implementation/download.bit
	@rm -f $(SYSTEM)_bd.bmm

implementation/$(SYSTEM).bit: implementation/$(SYSTEM).ngc etc/fast_runtime.opt __xps/xpsxflow.opt data/$(SYSTEM).ucf etc/bitgen.ut
	@echo "Copying Xilinx Implementation tool scripts.."
	@cp -f etc/bitgen.ut implementation/bitgen.ut
	@cp -f etc/fast_runtime.opt implementation/
	@cp -f data/$(SYSTEM).ucf implementation/$(SYSTEM).ucf
	@echo "*********************************************"
	@echo "Running Xilinx Implementation tools.."
	@echo "*********************************************"
	xflow -wd implementation -p $(DEVICE) -implement fast_runtime.opt $(SYSTEM).ngc
	cd implementation; bitgen -w -f bitgen.ut $(SYSTEM)

exporttopn: 
	@echo You have chosen XPS for implementation tool flow.
	@echo Please select ProjNav as your implementation flow in Project Options or use commad xset pnproj <nplfile> in batch mode

implementation/$(SYSTEM).ace:
	@echo "You must have exactly one ppc405 to generate ace file"

implementation/$(SYSTEM).ngc implementation/$(SYSTEM).bmm: \
$(MHSFILE) __xps/platgen.opt
	@echo "*********************************************"
	@echo "Creating system netlist for hardware specification.."
	@echo "*********************************************"
	platgen $(PLATGEN_OPTIONS) -st xst  $(MHSFILE)
	@echo "Running synthesis..."
	bash -c "cd synthesis; ./synthesis.sh; cd .."

$(LIBRARIES): $(MHSFILE) $(MSSFILE) __xps/libgen.opt
	@echo "*********************************************"
	@echo "Creating software libraries..."
	@echo "*********************************************"
	libgen $(LIBGEN_OPTIONS) $(MSSFILE)

#################################################################
# TARGETS/MACROS FOR SIMULATION FLOW
#################################################################


$(BEHAVIORAL_DO_SCRIPT): $(MHSFILE) __xps/simgen.opt \
 $(MICROBLAZE_INST_OUTPUT) 
	@echo "*********************************************"
	@echo "Creating behavioral simulation models..."
	@echo "*********************************************"
	simgen $(SIMGEN_OPTIONS) -m behavioral $(MHSFILE)  -pe microblaze_inst $(MICROBLAZE_INST_OUTPUT) 

$(STRUCTURAL_DO_SCRIPT): $(MHSFILE) __xps/simgen.opt \
 $(MICROBLAZE_INST_OUTPUT)  \
implementation/microblaze_inst_wrapper.ngc \
implementation/d_lmb_wrapper.ngc \
implementation/i_lmb_wrapper.ngc \
implementation/myopb_bus_wrapper.ngc \
implementation/dlmb_cntlr_wrapper.ngc \
implementation/ilmb_cntlr_wrapper.ngc \
implementation/bram_inst_wrapper.ngc \
implementation/zbt_cntlr_wrapper.ngc \
implementation/jtag_inst_wrapper.ngc \
implementation/uart_inst_wrapper.ngc \
implementation/gpio_button_in_wrapper.ngc \
implementation/gpio_y_wrapper.ngc \
implementation/gpio_cr_wrapper.ngc \
implementation/gpio_cb_wrapper.ngc \
implementation/video_block_inst_wrapper.ngc \
implementation/demultiplexer_inst_wrapper.ngc \
implementation/multiplexer_elab_inst_wrapper.ngc \
implementation/pb_scan_inst_wrapper.ngc \
implementation/scal2vect8bit_inst_wrapper.ngc
	@echo "*********************************************"
	@echo "Creating structural simulation models..."
	@echo "*********************************************"
	simgen $(SIMGEN_OPTIONS) -sd implementation -m structural $(MHSFILE)  -pe microblaze_inst $(MICROBLAZE_INST_OUTPUT) 

$(TIMING_DO_SCRIPT): $(MHSFILE) __xps/simgen.opt \
 $(MICROBLAZE_INST_OUTPUT)  \
implementation/$(SYSTEM).bit
	@echo "*********************************************"
	@echo "Creating timing simulation models..."
	@echo "*********************************************"
	simgen $(SIMGEN_OPTIONS) -sd implementation -m timing $(MHSFILE)  -pe microblaze_inst $(MICROBLAZE_INST_OUTPUT) 


implementation/microblaze_inst_wrapper.ngc \
implementation/d_lmb_wrapper.ngc \
implementation/i_lmb_wrapper.ngc \
implementation/myopb_bus_wrapper.ngc \
implementation/dlmb_cntlr_wrapper.ngc \
implementation/ilmb_cntlr_wrapper.ngc \
implementation/bram_inst_wrapper.ngc \
implementation/zbt_cntlr_wrapper.ngc \
implementation/jtag_inst_wrapper.ngc \
implementation/uart_inst_wrapper.ngc \
implementation/gpio_button_in_wrapper.ngc \
implementation/gpio_y_wrapper.ngc \
implementation/gpio_cr_wrapper.ngc \
implementation/gpio_cb_wrapper.ngc \
implementation/video_block_inst_wrapper.ngc \
implementation/demultiplexer_inst_wrapper.ngc \
implementation/multiplexer_elab_inst_wrapper.ngc \
implementation/pb_scan_inst_wrapper.ngc \
implementation/scal2vect8bit_inst_wrapper.ngc: $(MHSFILE) __xps/platgen.opt
	platgen $(PLATGEN_OPTIONS) $(MHSFILE)

dummy:
	@echo ""

